> ## Documentation Index
> Fetch the complete documentation index at: https://developer.jtl-software.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Generic Shipping Attributes

> Returns the catalog of generic shipping attributes provided by JTL (e.g. `IMEI`, `SERIAL_NUMBER`,
`DELIVERY_NOTE_NUMBER`). A channel activates the ones it needs via `activatedGenericAttributeList` on
`PUT /v1/channel/shipping-rules`.




## OpenAPI

````yaml /openapi/marketplace-channels/channel.json get /v1/channel/shipping-rules/generic-attributes
openapi: 3.0.2
info:
  title: JTL-Channel API
  version: 1.0.0
  x-logo:
    url: https://scx-sandbox.ui.jtl-software.com/docs/scx.png
  description: >
    JTL-Channel API is a REST-based API that helps a Channel Integrator to
    connect Marketplace with the JTL-Wawi 

    ERP System.


    # Key Features


    With the JTL-Channel API, you can:

      * Describe connected Marketplace Data Structure by providing Category and Attribute Data
      * Manage Product and Offer Listings
      * Manage Orders 
      * Handle the Post Order Process

    # Development Guide


    There is a detailed development guide available at
    [developer.jtl-software.com](https://developer.jtl-software.com/products/marketplaces/scx-channel-api/change_log).
servers:
  - url: https://scx-sbx.api.jtl-software.com
    description: Sandbox
  - url: https://scx.api.jtl-software.com
    description: Production
security: []
tags:
  - name: Seller
    description: |
      Seller Management
  - name: Channel
    description: Meta channel routes
  - name: Notification
    description: Channel notifications
  - name: Supported Prices
    description: Price type management
  - name: Meta
    description: meta
  - name: Attributes
    description: Channel attributes
  - name: Categories
    description: Channel categories
  - name: Order
    description: Orders
  - name: Return
    description: Order returns
  - name: Events
    description: SCX events
  - name: Offer
    description: Channel offers
  - name: Report
    description: SCX reports
  - name: Ticket
    description: Channel tickets
  - name: Stock Updates
    description: Stock update operations
paths:
  /v1/channel/shipping-rules/generic-attributes:
    get:
      tags:
        - Meta
      summary: Generic Shipping Attributes
      description: >
        Returns the catalog of generic shipping attributes provided by JTL (e.g.
        `IMEI`, `SERIAL_NUMBER`,

        `DELIVERY_NOTE_NUMBER`). A channel activates the ones it needs via
        `activatedGenericAttributeList` on

        `PUT /v1/channel/shipping-rules`.
      operationId: GetShippingRuleGenericAttributes
      responses:
        '200':
          $ref: '#/components/responses/GenericAttributeListResponse'
        '401':
          $ref: '#/components/responses/AccessForbidden'
        '500':
          $ref: '#/components/responses/ServerError'
      security:
        - ChannelAuth: []
components:
  responses:
    GenericAttributeListResponse:
      description: Generic shipping attribute catalog retrieved
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/GenericAttributeList'
    AccessForbidden:
      description: Access forbidden, invalid or unknown Token was used.
    ServerError:
      description: Unexpected Server Error
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseList'
          example:
            errorList:
              - code: GEN500
                message: Internal Server Error
                severity: error
                hint: null
  schemas:
    GenericAttributeList:
      description: Catalog of generic shipping attributes JTL provides across all channels.
      type: object
      required:
        - genericAttributeList
      properties:
        genericAttributeList:
          type: array
          items:
            $ref: '#/components/schemas/GenericShippingAttribute'
    ErrorResponseList:
      type: object
      properties:
        errorList:
          nullable: true
          type: array
          example:
            - code: GEN700
              message: Seller SELLER_4711 does not exist on channel kaufland.
              severity: error
              hint: i9n-order22
          items:
            title: Error
            type: object
            properties:
              code:
                type: string
                example: GEN700
              message:
                type: string
                example: Seller SELLER_4711 does not exist on channel kaufland.
              severity:
                type: string
                enum:
                  - error
                  - warning
                  - info
                default: error
              hint:
                type: string
                nullable: true
                example: i9n-order22
    GenericShippingAttribute:
      description: >
        A generic shipping attribute made available by JTL across all channels
        (e.g. `IMEI`, `SERIAL_NUMBER`,

        `DELIVERY_NOTE_NUMBER`). A channel activates the ones relevant to it via
        `activatedGenericAttributeList`.
      type: object
      required:
        - attributeId
        - displayName
        - type
        - level
      properties:
        attributeId:
          type: string
          minLength: 1
          maxLength: 150
          example: IMEI
        displayName:
          type: string
          maxLength: 150
          example: IMEI
        description:
          type: string
          maxLength: 1024
          example: International Mobile Equipment Identity
        type:
          $ref: '#/components/schemas/AttributeType'
        level:
          $ref: '#/components/schemas/ShippingAttributeLevel'
        enumValues:
          type: array
          items:
            $ref: '#/components/schemas/AllowedValue'
        attributeValueValidation:
          type: string
          maxLength: 1024
          example: /^[0-9]{15}$/
        isMultipleAllowed:
          type: boolean
          default: false
          example: false
        required:
          type: boolean
          default: false
          example: false
        recommended:
          type: boolean
          default: false
          example: false
    AttributeType:
      description: >
        Attribute type describes which kind of data is expected for a particular
        attribute.


        * Type **smalltext** is considered plain text and may not exceed more
        than 255 characters.

        * Type **text** is considered plain text and may not exceed a maximum
        length more than 50.000 characters.

        * Type **htmltext** may be used for text where HTML Markup is allowed.
        The maximum length should not exceed

        more than 50.000 characters.

        * Type **date** must follow [ISO
        8601](https://en.wikipedia.org/wiki/ISO_8601) standard with Timezone.

        * Type **enum** may provide a set of allowed choices via the values
        property

        * Type **image** a attribute with an existing remote File uploaded using
        `POST /v1/seller/offer/file`

        * Type **document** a attribute with an existing remote File uploaded
        using `POST /v1/seller/offer/file`

        * Type **url** must match a URL Schema

        * Type **label** can be used as help text. Requires description to be
        set
      type: string
      enum:
        - smalltext
        - htmltext
        - text
        - integer
        - decimal
        - enum
        - date
        - boolean
        - image
        - document
        - url
        - label
      example: text
      default: smalltext
    ShippingAttributeLevel:
      description: >
        Defines on which entity a shipping attribute is captured.


        * Level **ORDER_ITEM** the attribute value is captured per order item
        (e.g. `IMEI`, `SERIAL_NUMBER`).

        * Level **SHIPMENT** the attribute value is captured per shipment (e.g.
        `DELIVERY_NOTE_NUMBER`).
      type: string
      enum:
        - ORDER_ITEM
        - SHIPMENT
      example: ORDER_ITEM
    AllowedValue:
      type: object
      required:
        - value
      properties:
        value:
          description: >
            An enumeration to include in the set. The enumeration bust be
            string-based.

            Example: '1', 'green_l_st'
          type: string
          maxLength: 1024
          minLength: 1
        display:
          description: >
            An optional alias for the enumeration, which will be shown in the
            GUI. If left empty, the value will be shown instead.

            Example: 'Red', 'Light Green + Striped'
          type: string
          maxLength: 1024
          minLength: 1
        sort:
          description: Specifies the order of values
          type: integer
          default: 0
  securitySchemes:
    ChannelAuth:
      description: >
        As a Channel Integrator you will receive a API Refresh Token. With such
        a Refresh Token you

        need to request an Access Token with a limited Lifetime (see POST
        /v1/auth). This Access Token

        must be provided as a Bearer Token in the Authorization Header with
        every request.
      type: http
      scheme: bearer
      bearerFormat: JWT

````